=== packages/kokkos/benchmarks/gather/CMakeLists.txt ===
KOKKOS_ADD_EXECUTABLE(
  gather
  SOURCES main.cpp
)
